<template>
  <div class="user-last-login-add-on">
    <i class="bi bi-box-arrow-in-right me-2"></i>
    <span data-bs-toggle="tooltip" :title="lastLoginTooltip">Last login {{ lastLoginText }}</span>
  </div>
</template>

<script>
import { ref, computed, onUnmounted } from 'vue'
import { useStore } from 'vuex'
import { useMoment } from '../../core'

export default {
  name: 'UserLastLoginAddOn',
  props: {
    user: { type: Object, required: true },
  },
  setup(props) {
    const store = useStore()
    const moment = useMoment()

    const lastLoginText = ref('')
    const lastLoginTooltip = ref('')

    const neverLoggedOn = computed(() => {
      return moment(props.user.lastLoggedOn).format('YYYY') === '0000'
    })

    const updateRelativeMomentText = () => {
      if (neverLoggedOn.value) {
        lastLoginText.value = 'never'
        lastLoginTooltip.value = 'never'
      } else {
        const lastLoginRelative = moment(props.user.lastLoggedOn).fromNow()
        const lastLoginAbsolute = moment(props.user.lastLoggedOn).format('llll')

        const relativeDatetimes = store.state.core.persisted.relativeDatetimes
        lastLoginText.value = relativeDatetimes ? lastLoginRelative : lastLoginAbsolute
        lastLoginTooltip.value = relativeDatetimes ? lastLoginAbsolute : lastLoginRelative
      }
    }

    onUnmounted(() => {
      clearInterval(interval)
    })

    let interval = setInterval(() => {
      updateRelativeMomentText()
    }, 1000)

    updateRelativeMomentText()

    return {
      lastLoginText,
      lastLoginTooltip,
    }
  },
}
</script>
